%{?scl:%scl_package jctools}
%{!?scl:%global pkg_name %{name}}
%{?java_common_find_provides_and_requires}

%global namedreltag %nil
%global namedversion %{version}%{?namedreltag}

# non-SCL
%{!?scl:
%global objectweb_asm_maven_coords org.ow2.asm:asm-all
}
# SCL
%{?scl:
%global objectweb_asm_maven_coords org.ow2.asm:asm-all:5
}

%if 0%{?rhel} <= 6
  %global jdk8_home /usr/lib/jvm/java-1.8.0-openjdk.x86_64
%else
  %global jdk8_home /usr/lib/jvm/java-1.8.0-openjdk
%endif

Name:          %{?scl_prefix}jctools
Version:       1.2.1
Release:       2%{?dist}
Summary:       Java Concurrency Tools for the JVM
License:       ASL 2.0
URL:           http://jctools.github.io/JCTools/
Source0:       https://github.com/JCTools/JCTools/archive/v%{namedversion}/%{pkg_name}-%{namedversion}.tar.gz

# Build-only JDK 8 requirement. Runtime is JDK 6.
BuildRequires: java-1.8.0-openjdk-devel
BuildRequires: %{?scl_prefix_java_common}maven-local
BuildRequires: %{?scl_prefix_java_common}mvn(junit:junit)
BuildRequires: %{?scl_prefix_maven}mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: %{?scl_prefix_java_common}mvn(org.hamcrest:hamcrest-all)
BuildRequires: %{?scl_prefix_java_common}mvn(%{objectweb_asm_maven_coords})

BuildArch:     noarch

%description
This project aims to offer some concurrent data structures
currently missing from the JDK:

° SPSC/MPSC/SPMC/MPMC Bounded lock free queues
° SPSC/MPSC Unbounded lock free queues
° Alternative interfaces for queues
° Offheap concurrent ring buffer for ITC/IPC purposes
° Single Writer Map/Set implementations
° Low contention stats counters
° Executor

%package experimental
Summary:       JCTools Experimental implementations

%description experimental
Experimental implementations for the
Java Concurrency Tools Library.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%package parent
Summary:       JCTools Parent POM

%description parent
JCTools Parent POM.

%prep
%{?scl:scl enable %{scl_maven} %{scl} - << "EOF"}
%setup -q -n JCTools-%{namedversion}
# Cleanup
find . -name '*.class' -print -delete
find . -name '*.jar' -print -delete

# Ignore JDK 8 javadoc lint issues
%pom_xpath_inject pom:properties '<additionalparam>-Xdoclint:none</additionalparam>'

%pom_xpath_set pom:project/pom:version %{namedversion}
%pom_xpath_set -r pom:parent/pom:version %{namedversion} %{pkg_name}-core %{pkg_name}-experimental

# Prevent build failure
%pom_remove_plugin :maven-enforcer-plugin

# Unavailable deps
%pom_disable_module %{pkg_name}-benchmarks

# Not available
%pom_remove_plugin :cobertura-maven-plugin %{pkg_name}-core

# Useless tasks
%pom_remove_plugin :maven-source-plugin %{pkg_name}-core
%pom_xpath_remove "pom:plugin[pom:artifactId = 'maven-javadoc-plugin']/pom:executions" %{pkg_name}-core

%pom_xpath_set "pom:dependencies/pom:dependency[pom:artifactId = 'asm-all']/pom:version" "5.0.3" %{pkg_name}-experimental

# Add OSGi support
for mod in core experimental; do
 %pom_xpath_set "pom:project/pom:packaging" bundle %{pkg_name}-${mod}
 %pom_add_plugin org.apache.felix:maven-bundle-plugin:2.3.7 %{pkg_name}-${mod} '
 <extensions>true</extensions>
 <executions>
   <execution>
     <id>bundle-manifest</id>
     <phase>process-classes</phase>
     <goals>
       <goal>manifest</goal>
     </goals>
   </execution>
 </executions>
 <configuration>
  <excludeDependencies>true</excludeDependencies>
 </configuration>'
done
%{?scl:EOF}

%build
%{?scl:scl enable %{scl_maven} %{scl} - << "EOF"}
export JAVA_HOME=%{jdk8_home}
%mvn_build -s
%{?scl:EOF}

%install
%{?scl:scl enable %{scl_maven} %{scl} - << "EOF"}
%mvn_install
%{?scl:EOF}

%files -f .mfiles-%{pkg_name}-core
%doc README.md
%doc LICENSE

%files experimental -f .mfiles-%{pkg_name}-experimental

%files javadoc -f .mfiles-javadoc
%doc LICENSE

%files parent -f .mfiles-%{pkg_name}-parent
%doc LICENSE

%changelog
* Mon Oct 24 2016 Severin Gehwolf <sgehwolf@redhat.com> 1.2.1-2
- SCL-ize package.

* Wed Sep 28 2016 gil cattaneo <puntogil@libero.it> 1.2.1-1
- update to 1.2.1

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.1-0.3.alpha
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1-0.2.alpha
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Tue May 19 2015 gil cattaneo <puntogil@libero.it> 1.1-0.1.alpha
- initial rpm
